<bugID>1042461<Summary>Update hotfix resumes when it shouldn't</Summary><Description>It looks like the HTTP download resume code in the hotfix is busted.

This log shows us resuming after a 403 response among other weirdness. We're almost certainly a) saving when we shouldn't be b) not removing a partial file when we should be.

1405669638736   channel:onStartRequest()
1405669638737   Download is resumable.
1405669638737   Saving state file.
1405669638760   channel:onStopRequest(NS_OK)
1405669638760   Got HTTP 403
1405669638760   Closing pipe due to failed channel.
1405669638760   copier:onStartRequest()
1405669638804   State save finished.
1405669638828   copier:onStopRequest(NS_BINDING_ABORTED)
1405669638828   Channel didn't complete successfully.
1405669638828   Download did not complete successfully.
1405669638828   Download failed. Attempt 1
1405673552385   Retry timer fired. Attempting another download and/or update.
1405673552385   Starting download. Attempt 2
1405673552385   Saving state file.
1405673552403   Resuming download at byte offset 606
1405673552640   channel:onStartRequest()
1405673552640   Download is resumable.
1405673552640   Deferring save because another in progress.
1405673552644   channel:onStopRequest(NS_ERROR_NOT_RESUMABLE)
1405673552644   Closing pipe due to failed channel.
1405673552645   copier:onStartRequest()
1405673552645   copier:onStopRequest(NS_BINDING_ABORTED)
1405673552645   Channel didn't complete successfully.
1405673552645   Download did not complete successfully.
1405673552645   Download failed. Attempt 2

After a restart:

1405908556225   Starting download. Attempt 4
1405908556235   Saving state file.
1405908556257   Resuming download at byte offset 606
1405908556322   State save finished.
1405908558076   channel:onStartRequest()
1405908558099   Entity ID changed!
1405908558099   Saving state file.
1405908558100   Download is resumable.
1405908558100   Deferring save because another in progress.
1405908558252   channel:onStopRequest(NS_ERROR_ENTITY_CHANGED)
1405908558253   Closing pipe due to failed channel.
1405908558253   copier:onStartRequest()
1405908558253   State save finished.
1405908558253   Saving state file from chain.
1405908558255   copier:onStopRequest(NS_BINDING_ABORTED)
1405908558255   Channel didn't complete successfully.
1405908558255   Download did not complete successfully.
1405908558255   Download failed. Attempt 4
1405908558292   State save finished.
1405931001876   Retry timer fired. Attempting another download and/or update.
1405931001877   Starting download. Attempt 5
1405931001877   Saving state file.
1405931001883   Resuming download at byte offset 606
1405931001960   State save finished.
1405931003665   channel:onStartRequest()
1405931003666   Download is resumable.
1405931003666   Saving state file.
1405931003669   copier:onStartRequest()
1405931003717   State save finished.
1405931004948   Download progress: 1003270/29836648
1405931007688   Download progress: 2005382/29836648
1405931011150   Download progress: 3006746/29836648
...
1405931083506   Download progress: 29036730/29836648
1405931085754   channel:onStopRequest(NS_OK)
1405931085754   Got HTTP 206
1405931085756   copier:onStopRequest(NS_OK)
1405931085756   Verifying download.
1405931087123   File hash mismatch!
1405931087123   Saving state file.
1405931087123   Download failure #1
1405931087123   Removing temp file due to failed verification.
1405931087130   Deferring save because another in progress.
1405931087130   Download failed. Attempt 5
1405931087204   State save finished.
1405931087205   Saving state file from chain.
1405931087281   State save finished.
1405934687127   Retry timer fired. Attempting another download and/or update.
1405934687128   Starting download. Attempt 6
1405934687128   Saving state file.
1405934687290   State save finished.
1405934687327   channel:onStartRequest()
1405934687327   Download is resumable.
1405934687327   Saving state file.
1405934687329   channel:onStopRequest(NS_OK)
1405934687329   Got HTTP 200
1405934687330   copier:onStartRequest()
1405934687406   State save finished.
1405934687409   copier:onStopRequest(NS_OK)
1405934687409   Verifying download.
1405934687410   File size does not match: 858 != 29836648
1405934687410   Saving state file.
1405934687411   Download failure #2
1405934687411   Removing temp file due to failed verification.
1405934687412   Deferring save because another in progress.</Description></bugID>